diff -Naur opencascade-7.3.0/adm/cmake/occt_csf.cmake opencascade-7.3.0-patched/adm/cmake/occt_csf.cmake
--- opencascade-7.3.0/adm/cmake/occt_csf.cmake	2018-05-25 21:13:23.000000000 +0200
+++ opencascade-7.3.0-patched/adm/cmake/occt_csf.cmake	2018-08-28 14:10:56.198736681 +0200
@@ -72,7 +72,7 @@
   set (CSF_gdi32         "gdi32.lib")
   set (CSF_user32        "user32.lib")
   set (CSF_wsock32       "wsock32.lib")
-  set (CSF_psapi         "Psapi.lib")
+  set (CSF_psapi         "psapi.lib")
   set (CSF_d3d9          "D3D9.lib")
   if ("${CMAKE_SYSTEM_NAME}" STREQUAL "WindowsStore" OR USE_GLES2)
     set (CSF_OpenGlLibs  "libEGL libGLESv2")
diff -Naur opencascade-7.3.0/src/Draw/CommandWindow.cxx opencascade-7.3.0-patched/src/Draw/CommandWindow.cxx
--- opencascade-7.3.0/src/Draw/CommandWindow.cxx	2018-05-25 21:13:38.000000000 +0200
+++ opencascade-7.3.0-patched/src/Draw/CommandWindow.cxx	2018-08-28 15:08:26.927716093 +0200
@@ -17,9 +17,9 @@
 #ifdef _WIN32
 #include <windows.h>
 
-#include <CommandWindow.h>
+#include <COMMANDWINDOW.h>
 #include <Draw_Window.hxx>
-#include <MainWindow.h>
+#include <MAINWINDOW.h>
 #include <Draw_Appli.hxx>
 #include <TCollection_AsciiString.hxx>
 
diff -Naur opencascade-7.3.0/src/Draw/MAINWINDOW.h opencascade-7.3.0-patched/src/Draw/MAINWINDOW.h
--- opencascade-7.3.0/src/Draw/MAINWINDOW.h	2018-05-25 21:13:38.000000000 +0200
+++ opencascade-7.3.0-patched/src/Draw/MAINWINDOW.h	2018-08-28 15:09:12.755859115 +0200
@@ -26,7 +26,7 @@
 /*
 ** PROCEDURES DE MAIN WINDOW
 */
-#include <Windows.h>
+#include <windows.h>
 
 LRESULT APIENTRY WndProc(HWND, UINT, WPARAM, LPARAM);
 BOOL CreateProc(HWND);
diff -Naur opencascade-7.3.0/src/OSD/OSD.cxx opencascade-7.3.0-patched/src/OSD/OSD.cxx
--- opencascade-7.3.0/src/OSD/OSD.cxx	2018-05-25 21:13:53.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD.cxx	2018-08-28 13:53:26.852061064 +0200
@@ -22,11 +22,11 @@
 				    Standard_PCharacter& aString)
 {
   char *p, *q ;
-  
+
   if (Sprintf(aString,"%.17e",aReal)  <= 0) //BUC60808
     return Standard_False ;
 
-  // Suppress "e+00" and unsignificant 0's 
+  // Suppress "e+00" and unsignificant 0's
 
   p = strchr(aString,'e');
   if (p) {
@@ -57,11 +57,11 @@
 
 //=======================================================================
 //function : OSDSecSleep
-//purpose  : Cause the process to sleep during a amount of seconds 
+//purpose  : Cause the process to sleep during a amount of seconds
 //=======================================================================
 
 #ifdef _WIN32
-# include <Windows.h>
+# include <windows.h>
 # define SLEEP(NSEC)                 Sleep(1000*(NSEC))
 #else
 #include <unistd.h>
@@ -75,7 +75,7 @@
 
 //=======================================================================
 //function : MilliSecSleep
-//purpose  : Cause the process to sleep during a amount of milliseconds  
+//purpose  : Cause the process to sleep during a amount of milliseconds
 //=======================================================================
 
 #ifdef _WIN32
diff -Naur opencascade-7.3.0/src/OSD/OSD_Error.cxx opencascade-7.3.0-patched/src/OSD/OSD_Error.cxx
--- opencascade-7.3.0/src/OSD/OSD_Error.cxx	2018-05-25 21:13:53.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_Error.cxx	2018-08-28 13:54:18.780400530 +0200
@@ -52,7 +52,7 @@
  return(extCode);
 }
 
- 
+
 void OSD_Error::Perror() {
  TCollection_AsciiString buffer;
 
@@ -78,7 +78,7 @@
   case EBADMSG:
    switch (myCode){
     case OSD_WFile:
-     buffer += 
+     buffer +=
      "The message waiting to be read on stream is not a data message";
      extCode = ERR_FBADMSG;
      break;
@@ -88,7 +88,7 @@
    break;
 #endif
 
-  case EINVAL: 
+  case EINVAL:
    switch (myCode){
     case OSD_WFileNode:
       buffer += "Can't unlink '.' or '..'";
@@ -152,7 +152,7 @@
      break;
    }
    break;
-  case EACCES: 
+  case EACCES:
     buffer += "Permission denied";
     extCode = ERR_ACCESS;
     break;
@@ -176,7 +176,7 @@
       break;
    }
    break;
-  case EPERM: 
+  case EPERM:
    switch (myCode){
     case OSD_WPackage:
      buffer += "Permission denied";
@@ -186,7 +186,7 @@
      buffer += "Permission denied or can't unlink directory";
      extCode = ERR_FPERM;
      break;
-    default : 
+    default :
      buffer += "abnormal error : you modified OSD library";
      extCode = ERR_PERM;
      break;
@@ -308,7 +308,7 @@
    switch (myCode){
     case OSD_WFile:
      buffer += "Exceed process's file size limit or the maximum file size";
-     extCode = ERR_FFBIG; 
+     extCode = ERR_FFBIG;
      break;
     default:
      break;
@@ -318,12 +318,12 @@
    buffer += "operation breaked by a signal";
    extCode = ERR_INTR;
    break;
-  case ENOMEM: 
+  case ENOMEM:
    buffer += "Not enough memory";
    extCode = ERR_NOMEM;
    break;
-  case EMFILE : 
-   switch(myCode){   
+  case EMFILE :
+   switch(myCode){
     case OSD_WFile :
        buffer += "Too many file descriptors are currently in use by this process";
        extCode = ERR_FMFILE;
@@ -403,7 +403,7 @@
    break;
 #endif
 
-  case EEXIST: 
+  case EEXIST:
    switch(myCode){
     case OSD_WFileNode:
      buffer += "Directory not empty";
@@ -419,7 +419,7 @@
      break;
    }
    break;
-  case E2BIG: 
+  case E2BIG:
    buffer += "Too many Semaphore/Shared memory for a process.";
    buffer += "Reconfigure Kernel with greater values";
    extCode = ERR_TOOBIG;
@@ -448,7 +448,7 @@
 #include <TCollection_ExtendedString.hxx>
 
 #include <windows.h>
-#include <Strsafe.h>
+#include <strsafe.h>
 
 typedef struct _error_table {
 
@@ -561,7 +561,7 @@
 
 static Standard_Integer _get_comm_error ( DWORD );
 
-OSD_Error :: OSD_Error () : 
+OSD_Error :: OSD_Error () :
    myCode((OSD_WhoAmI)0),
    extCode(0)
 {
@@ -575,7 +575,7 @@
   StringCchCopyW(buff, _countof(buff), L"Error ( ");
 
   switch ( myCode ) {
-  
+
    case OSD_WDirectoryIterator:
      StringCchCatW(buff, _countof(buff), L"OSD_DirectoryIterator");
    break;
@@ -624,7 +624,7 @@
   StringCchCatW(buff, _countof(buff), L" )");
 
   std::wcerr << buff;
- 
+
  std::cerr << myMessage.ToCString() << std::endl << std::flush;
 
 }  // end OSD_Error :: Perror
@@ -642,7 +642,7 @@
  myMessage = Message;
 
  switch ( From ) {
- 
+
   case OSD_WDirectory:
 
    for ( i = 0; i < DIR_ERR_TABLE_SIZE; ++i )
@@ -672,7 +672,7 @@
   if ( i == FILE_ERR_TABLE_SIZE ) extCode = _get_comm_error ( Errcode );
 
   break;
- 
+
   case OSD_WFileNode:
 
    for ( i = 0; i < FILE_NODE_ERR_TABLE_SIZE; ++i )
diff -Naur opencascade-7.3.0/src/OSD/OSD_File.cxx opencascade-7.3.0-patched/src/OSD/OSD_File.cxx
--- opencascade-7.3.0/src/OSD/OSD_File.cxx	2018-05-25 21:14:01.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_File.cxx	2018-08-28 13:55:40.048930438 +0200
@@ -34,7 +34,7 @@
   #include <stdio.h>
   #include <io.h>
 
-  #include <Strsafe.h>
+  #include <strsafe.h>
 
   #define ACE_HEADER_SIZE (sizeof(ACCESS_ALLOWED_ACE) - sizeof (DWORD))
 
diff -Naur opencascade-7.3.0/src/OSD/OSD_FileNode.cxx opencascade-7.3.0-patched/src/OSD/OSD_FileNode.cxx
--- opencascade-7.3.0/src/OSD/OSD_FileNode.cxx	2018-05-25 21:14:01.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_FileNode.cxx	2018-08-28 13:56:12.429141158 +0200
@@ -72,7 +72,7 @@
 
 
 // Test if specified file/directory exists
- 
+
 Standard_Boolean  OSD_FileNode::Exists(){
 int status;
 
@@ -85,7 +85,7 @@
  TCollection_AsciiString aBuffer;
  myPath.SystemName ( aBuffer );
  status = access ( aBuffer.ToCString() , F_OK );
- 
+
  if (status == 0) return (Standard_True);
    else return ( Standard_False );
 }
@@ -118,7 +118,7 @@
      myError.SetValue (errno, Iam, "Remove");
      return;
    }
-  
+
  if (  S_ISDIR(stat_buf.st_mode))  {
    // DIRECTORY
 
@@ -127,13 +127,13 @@
        myError.SetValue (errno, Iam, "Remove");
        return;
      }
-   return; 
+   return;
 
  }
  else if  (  S_ISREG(stat_buf.st_mode) || S_ISLNK(stat_buf.st_mode) ||
-             S_ISFIFO(stat_buf.st_mode)   )  { 
-   
-   if (unlink ( aBuffer.ToCString()) == -1) 
+             S_ISFIFO(stat_buf.st_mode)   )  {
+
+   if (unlink ( aBuffer.ToCString()) == -1)
      myError.SetValue (errno, Iam, "Remove");
    return;
  }
@@ -379,7 +379,7 @@
 # include <tchar.h>
 #endif  // _INC_TCHAR
 
-#include <Strsafe.h>
+#include <strsafe.h>
 
 #define TEST_RAISE( arg ) _test_raise (  fName, ( arg )  )
 #define RAISE( arg ) throw Standard_ProgramError (  ( arg )  )
@@ -403,7 +403,7 @@
 //purpose  : Empty Constructor
 //=======================================================================
 
-OSD_FileNode::OSD_FileNode () 
+OSD_FileNode::OSD_FileNode ()
 {
 }
 
@@ -419,7 +419,7 @@
 
 //=======================================================================
 //function : Path
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::Path ( OSD_Path& Name ) const {
@@ -430,7 +430,7 @@
 
 //=======================================================================
 //function : SetPath
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::SetPath ( const OSD_Path& Name ) {
@@ -441,7 +441,7 @@
 
 //=======================================================================
 //function : Exists
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 Standard_Boolean OSD_FileNode::Exists ()
@@ -479,7 +479,7 @@
 
 //=======================================================================
 //function : Remove
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::Remove () {
@@ -502,7 +502,7 @@
   case FLAG_DIRECTORY:
 
 
-// LD : Suppression de l'appel a DeleteDirectory pour 
+// LD : Suppression de l'appel a DeleteDirectory pour
 //      ne pas detruire un repertoire no vide.
 
    if (!RemoveDirectoryW (fNameW.ToWideString()))
@@ -517,7 +517,7 @@
 
 //=======================================================================
 //function : Move
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::Move ( const OSD_Path& NewPath ) {
@@ -557,7 +557,7 @@
 
 //=======================================================================
 //function : Copy
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::Copy ( const OSD_Path& ToPath ) {
@@ -603,7 +603,7 @@
 
 //=======================================================================
 //function : Protection
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 OSD_Protection OSD_FileNode::Protection () {
@@ -622,7 +622,7 @@
           pSD, retVal,
           _get_file_type (fName.ToCString(), INVALID_HANDLE_VALUE) == FLAG_DIRECTORY)
  )
-   
+
    _osd_wnt_set_error ( myError, OSD_WFileNode );
 
  if ( pSD != NULL )
@@ -635,7 +635,7 @@
 
 //=======================================================================
 //function : SetProtection
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::SetProtection ( const OSD_Protection& Prot ) {
@@ -651,7 +651,7 @@
  pSD = _osd_wnt_protection_to_sd (Prot,
         _get_file_type (fName.ToCString(), INVALID_HANDLE_VALUE) == FLAG_DIRECTORY,
         fNameW.ToWideString());
- 
+
  if (pSD == NULL || !SetFileSecurityW (fNameW.ToWideString(), DACL_SECURITY_INFORMATION, pSD))
   _osd_wnt_set_error (myError, OSD_WFileNode, fNameW.ToWideString());
 
@@ -667,7 +667,7 @@
 
 //=======================================================================
 //function : Protection
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 OSD_Protection OSD_FileNode::Protection ()
@@ -692,7 +692,7 @@
 
 //=======================================================================
 //function : SetProtection
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::SetProtection ( const OSD_Protection& /*Prot*/ )
@@ -703,7 +703,7 @@
 
 //=======================================================================
 //function : AccessMoment
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 Quantity_Date OSD_FileNode::AccessMoment () {
@@ -743,7 +743,7 @@
 
 //=======================================================================
 //function : CreationMoment
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 Quantity_Date OSD_FileNode::CreationMoment () {
@@ -783,7 +783,7 @@
 
 //=======================================================================
 //function : Failed
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 Standard_Boolean OSD_FileNode::Failed () const {
@@ -794,7 +794,7 @@
 
 //=======================================================================
 //function : Reset
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::Reset () {
@@ -805,7 +805,7 @@
 
 //=======================================================================
 //function : Perror
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 void OSD_FileNode::Perror () {
@@ -816,7 +816,7 @@
 
 //=======================================================================
 //function : Error
-//purpose  : 
+//purpose  :
 //=======================================================================
 
 Standard_Integer OSD_FileNode::Error () const {
@@ -900,11 +900,11 @@
  }  // end __try
 
  __finally {
- 
+
   if ( hFile != INVALID_HANDLE_VALUE )
 
    CloseHandle ( hFile );
- 
+
  }  // end __finally
 
  return retVal;
diff -Naur opencascade-7.3.0/src/OSD/OSD_MemInfo.cxx opencascade-7.3.0-patched/src/OSD/OSD_MemInfo.cxx
--- opencascade-7.3.0/src/OSD/OSD_MemInfo.cxx	2018-05-25 21:14:01.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_MemInfo.cxx	2018-08-28 14:01:52.447343151 +0200
@@ -18,7 +18,7 @@
   #include <winbase.h>
   #include <process.h>
   #include <malloc.h>
-  #include <Psapi.h>
+  #include <psapi.h>
   #ifdef _MSC_VER
     #pragma comment(lib, "Psapi.lib")
   #endif
diff -Naur opencascade-7.3.0/src/OSD/OSD_Process.cxx opencascade-7.3.0-patched/src/OSD/OSD_Process.cxx
--- opencascade-7.3.0/src/OSD/OSD_Process.cxx	2018-05-25 21:14:02.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_Process.cxx	2018-08-28 14:05:38.932802433 +0200
@@ -182,7 +182,7 @@
 #include <TCollection_ExtendedString.hxx>
 
 #include <OSD_WNT.hxx>
-#include <LMCONS.H> // for UNLEN - maximum user name length GetUserName()
+#include <lmcons.h> // for UNLEN - maximum user name length GetUserName()
 
 void _osd_wnt_set_error ( OSD_Error&, OSD_WhoAmI, ... );
 
diff -Naur opencascade-7.3.0/src/OSD/OSD_signal.cxx opencascade-7.3.0-patched/src/OSD/OSD_signal.cxx
--- opencascade-7.3.0/src/OSD/OSD_signal.cxx	2018-05-25 21:14:02.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_signal.cxx	2018-08-28 14:06:01.380946853 +0200
@@ -28,7 +28,7 @@
 #endif
 #include <windows.h>
 
-#include <Strsafe.h>
+#include <strsafe.h>
 
 #ifndef STATUS_FLOAT_MULTIPLE_FAULTS
   // <ntstatus.h>
diff -Naur opencascade-7.3.0/src/OSD/OSD_WNT.cxx opencascade-7.3.0-patched/src/OSD/OSD_WNT.cxx
--- opencascade-7.3.0/src/OSD/OSD_WNT.cxx	2018-05-25 21:14:02.000000000 +0200
+++ opencascade-7.3.0-patched/src/OSD/OSD_WNT.cxx	2018-08-28 14:06:58.341313165 +0200
@@ -23,7 +23,7 @@
 /***/
 #include <OSD_WNT.hxx>
 
-#include <Strsafe.h>
+#include <strsafe.h>
 #include <wchar.h>
 #include <stdlib.h>
 
diff -Naur opencascade-7.3.0/src/Standard/Standard_MMgrOpt.cxx opencascade-7.3.0-patched/src/Standard/Standard_MMgrOpt.cxx
--- opencascade-7.3.0/src/Standard/Standard_MMgrOpt.cxx	2018-05-25 21:14:11.000000000 +0200
+++ opencascade-7.3.0-patched/src/Standard/Standard_MMgrOpt.cxx	2018-08-28 14:07:10.525391495 +0200
@@ -35,7 +35,7 @@
 #endif
 
 #ifdef _WIN32
-#include <Strsafe.h>
+#include <strsafe.h>
 #endif
 //======================================================================
 // Assumptions